<?php
/**
 * GreyDream BulletinBoard (GBB)
 * Copyright ?2004 Grey Dream, All Rights Reserved
 *
 * Our Site: http://www.greydream.com
 *
 */




require "./global.php";
require "./inc/functions_post.php";

// Load global language phrases
$lang->load("moderation");


// Get some navigation if we need it
switch($action)
{
	case "reports":
//		addnav($lang->moderator_cp, "moderation.php");
		addnav($lang->reported_posts);
		break;
}

if($pid)
{
	$post = getpost($pid);
	$tid = $post['tid'];
	if(!$post['pid'])
	{
		error($lang->error_invalidpost);
	}
}

if($tid)
{
	$thread = getthread($tid);
	$fid = $thread['fid'];
	if(!$thread['tid'])
	{
		error($lang->error_invalidthread);
	}
}

if($fid)
{
	$modlogdata['fid'] = $fid;
	$forum = getforum($fid);

	// Make navigation
	makeforumnav($fid);
}

if($tid)
{
	addnav($thread['subject'], "showthread.php?tid=$thread[tid]");
	$modlogdata['tid'] = $tid;
}

// Get our permissions all nice and setup
$permissions = getpermissions($fid);

if($fid)
{
	// Password protected forums ......... yhummmmy!
	checkpwforum($fid, $forum['password']);
}

if($GBB['uid'] != 0)
{
	eval("\$loginbox = \"".$templates->get("changeuserbox")."\";");
}
else
{
	eval("\$loginbox = \"".$templates->get("loginbox")."\";");
}

// Begin!
switch($action)
{
	// Open or close a thread
	case "openclosethread":
		if(ismod($fid, "canopenclosethreads") != "yes")
		{
			nopermission();
		}
		if($thread['closed'] == "yes")
		{
			$openclose = "opened";
			$thread['closed'] = "no";
			$redirect = $lang->redirect_openthread;
		}
		else
		{
			$openclose = "closed";
			$thread['closed'] = "yes";
			$redirect = $lang->redirect_closethread;
		}
		logmod($modlogdata, "Thread $openclose");
		$db->query("UPDATE ".TABLE_PREFIX."threads SET closed='$thread[closed]' WHERE tid='$tid'");
		redirect("showthread.php?tid=$tid", $redirect);
		break;
	
	// Stick or unstick that post to the top bab!
	case "stick";
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		if($thread['sticky'] == 1)
		{
			$stuckunstuck = "unstuck";
			$thread['sticky'] = "0";
			$redirect = $lang->redirect_unstickthread;
		}
		else
		{
			$stuckunstuck = "stuck";
			$thread['sticky'] = "1";
			$redirect = $lang->redirect_stickthread;
		}
		logmod($modlogdata, "Thread $stuckunstuck");
		$db->query("UPDATE ".TABLE_PREFIX."threads SET sticky='$thread[sticky]' WHERE tid='$tid'");
		redirect("showthread.php?tid=$tid", $redirect);
		break;

	// Remove redirects to a specific thread
	case "removeredirects":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$db->query("DELETE FROM ".TABLE_PREFIX."threads WHERE closed='moved|$tid'");
	
		updateforumcount($fid);
		logmod($modlogdata, "Thread Redirects Removed");
		redirect("showthread.php?tid=$tid", $lang->redirect_redirectsmoved);
		break;

	// Delete thread confirmation page
	case "deletethread":
		addnav($lang->nav_deletethread);

		if(ismod($fid, "candeleteposts") != "yes")
		{
			if($permissions['candeletethreads'] != "yes" || $GBB['uid'] != $thread['uid'])
			{
				nopermission();
			}
		}

		eval("\$deletethread = \"".$templates->get("moderation_deletethread")."\";");
		outputpage($deletethread);
		break;

	// Delete the actual thread here
	case "do_deletethread":
		if(ismod($fid, "candeleteposts") != "yes")
		{
			if($permissions['candeletethreads'] != "yes" || $GBB['uid'] != $thread['uid'])
			{
				nopermission();
			}
		}
		$thread['subject'] = addslashes($thread['subject']);
		logmod($modlogdata, "Thread Deleted: $thread[subject]");
		deletethread($tid);
		updateforumcount($fid);
		markreports($tid, "thread");
		redirect("forumdisplay.php?fid=$fid", $lang->redirect_threaddeleted);
		break;

	// Delete the poll from a thread confirmation page
	case "deletepoll":
		addnav($lang->nav_deletepoll);

		if(ismod($fid, "candeleteposts") != "yes")
		{
			if($permissions['candeletethreads'] != "yes" || $GBB['uid'] != $thread['uid'])
			{
				nopermission();
			}
		}
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."polls WHERE tid='$tid'");
		$poll = $db->fetch_array($query);
		if(!$poll['pid'])
		{
			error($lang->error_invalidpoll);
		}

		eval("\$deletepoll = \"".$templates->get("moderation_deletepoll")."\";");
		outputpage($deletepoll);
		break;

	// Delete the actual poll here!
	case "do_deletepoll":
		if(ismod($fid, "candeleteposts") != "yes")
		{
			if($permissions['candeletethreads'] != "yes" || $GBB['uid'] != $thread['uid'])
			{
				nopermission();
			}
		}
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."polls WHERE tid='$tid'");
		$poll = $db->fetch_array($query);
		if(!$poll['pid'])
		{
			error($lang->error_invalidpoll);
		}

		logmod($modlogdata, "Poll Deleted: $thread[subject]");
		$db->query("DELETE FROM polls WHERE pid='$poll[pid]'");
		$db->query("DELETE FROM pollvotes WHERE pid='$poll[pid]'");
		$db->query("UPDATE threads SET poll='' WHERE poll='$poll[pid]'");

		redirect("showthread.php?tid=$tid", $lang->redirect_polldeleted);
		break;

	// Delete selective posts in a thread
	case "deleteposts":
		addnav($lang->nav_deleteposts);
		if(ismod($fid, "candeleteposts") != "yes")
		{
			nopermission();
		}
		$query = $db->query("SELECT p.*, u.* FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (p.uid=u.uid) WHERE tid='$tid' ORDER BY dateline ASC");	
		$altbg = "trow1";
		while($post = $db->fetch_array($query))
		{
			$postdate = mydate($settings['dateformat'], $post['dateline']);
			$posttime = mydate($settings['timeformat'], $post['dateline']);
			$message = stripslashes($post['message']);
			if($post['smilieoff'] == "yes")
			{
				$allowsmilies = "no";
			}
			else
			{
				$allowsmilies = $forum['allowsmilies'];
			}
			$message = postify($message, $forum['allowhtml'], $forum['allowmycode'], $allowsmilies, $forum['allowimgcode']);
			eval("\$posts .= \"".$templates->get("moderation_deleteposts_post")."\";");
			if($altbg == "trow1")
			{
				$altbg = "trow2";
			}
			else
			{
				$altbg = "trow1";
			}
		}
		eval("\$deleteposts = \"".$templates->get("moderation_deleteposts")."\";");
		outputpage($deleteposts);
		break;

	// Lets delete those selected posts!
	case "do_deleteposts":
		if(ismod($fid, "candeleteposts") != "yes")
		{
			nopermission();
		}
		$deletethread = "1";
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE tid='$tid'");
		while($post = $db->fetch_array($query))
		{
			if($deletepost[$post['pid']] == "yes")
			{
				deletepost($post['pid']);
				$deletecount++;
				$plist[] = $post['pid'];
			}
		else
			{
				$deletethread = "0";
			}
		}
		if($deletethread)
		{
			deletethread($tid);
			$url = "forumdisplay.php?fid=$fid";
			markreports($plist, "posts");
		}
		else
		{
			updatethreadcount($tid);
			$url = "showthread.php?tid=$tid";
			markreports($tid, "thread");
		}
		logmod($modlogdata, "Deleted Selective Posts ($deletecount)");
		updateforumcount($fid);
		redirect($url, $lang->redirect_postsdeleted);
		break;
	
	// Merge selected posts selection screen
	case "mergeposts":
		addnav($lang->nav_mergeposts);
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$query = $db->query("SELECT p.*, u.* FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (p.uid=u.uid) WHERE tid='$tid' ORDER BY dateline ASC");	
		$altbg = "trow1";
		while($post = $db->fetch_array($query))
		{
			$postdate = mydate($settings['dateformat'], $post['dateline']);
			$posttime = mydate($settings['timeformat'], $post['dateline']);
			$message = stripslashes($post['message']);
			if($post['smilieoff'] == "yes")
			{
				$allowsmilies = "no";
			}
			else
			{
				$allowsmilies = $forum['allowsmilies'];
			}
			$message = postify($message, $forum['allowhtml'], $forum['allowmycode'], $allowsmilies, $forum['allowimgcode']);
			eval("\$posts .= \"".$templates->get("moderation_mergeposts_post")."\";");
			if($altbg == "trow1")
			{
				$altbg = "trow2";
			}
			else
			{
				$altbg = "trow1";
			}
		}
		eval("\$mergeposts = \"".$templates->get("moderation_mergeposts")."\";");
		outputpage($mergeposts);
		break;

	// Lets merge those selected posts!
	case "do_mergeposts":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		if(count($mergepost) <= 1)
		{
			error($lang->error_nomergeposts);
		}
		$comma = "";
		while(list($pid, $yes) = @each($mergepost))
		{
			if($yes == "yes")
			{
				$pidin .= "$comma'$pid'";
				$comma = ",";
				$plist[] = $pid;
			}
		}
		$first = 1;
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE tid='$tid' AND pid IN($pidin) ORDER BY dateline ASC");
		while($post = $db->fetch_array($query))
		{
			if($first == 1)
			{ // all posts will be merged into this one
				$masterpid = $post['pid'];
				$message = $post['message'];
			}
			else
			{ // these are the selected posts
				$message .= "[hr]$post[message]";
			}
			$first = 0;
		}
		$message = addslashes($message);
		$db->query("UPDATE ".TABLE_PREFIX."posts SET message='$message' WHERE pid='$masterpid'");
		$db->query("DELETE FROM ".TABLE_PREFIX."posts WHERE pid IN($pidin) AND pid!='$masterpid'");
		$db->query("UPDATE ".TABLE_PREFIX."posts SET pid='$masterpid' WHERE pid IN($pidin)");
		updatethreadcount($tid);
		updateforumcount($fid);
		markreports($plist, "posts");
		logmod($modlogdata, "Merge Selective Posts");
		redirect("showthread.php?tid=$tid", $lang->redirect_mergepsots);
		break;
	
	// Move a thread
	case "move":
		addnav($lang->nav_move);
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$forumselect = makeforumjump("", "", 1, "", 0, "", "moveto");
		eval("\$movethread = \"".$templates->get("moderation_move")."\";");
		outputpage($movethread);
		break;

	// Lets get this thing moving!
	case "do_move":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		if(ismod($moveto, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$newperms = getpermissions($moveto);
		if($newperms['canview'] == "no")
		{
			nopermission();
		}
		$db->query("DELETE FROM ".TABLE_PREFIX."threads WHERE closed='moved|$tid' AND fid='$moveto'");
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."forums WHERE fid='$moveto'");
		$newforum = $db->fetch_array($query);
		if($newforum['type'] != "f")
		{
			error($lang->error_invalidforum);
		}
		if($method != "copy" && $thread['fid'] == $moveto)
		{
			error($lang->error_movetosameforum);
		}
		if($method == "move")
		{ // plain move thread
			$db->query("UPDATE ".TABLE_PREFIX."threads SET fid='$moveto' WHERE tid='$tid'");
			$db->query("UPDATE ".TABLE_PREFIX."posts SET fid='$moveto' WHERE tid='$tid'");
			logmod($modlogdata, "Thread Moved");
		}
		elseif($method == "redirect")
		{ // move (and leave redirect) thread
			$db->query("UPDATE ".TABLE_PREFIX."threads SET fid='$moveto' WHERE tid='$tid'");
			$db->query("UPDATE ".TABLE_PREFIX."posts SET fid='$moveto' WHERE tid='$tid'");
			$rsubject = addslashes($thread['subject']);
			$db->query("INSERT INTO ".TABLE_PREFIX."threads (tid,fid,subject,icon,uid,username,dateline,lastpost,lastposter,views,replies,closed,sticky,visible) VALUES (NULL,'$thread[fid]','$rsubject','$thread[icon]','$thread[uid]','$thread[username]','$thread[dateline]','$thread[lastpost]','$thread[lastposter]','$thread[views]','$thread[replies]','moved|$tid','$thread[sticky]', '1')");
			logmod($modlogdata, "Thread Moved");
		}
		else
		{ // copy thread
		// we need to add code to copy attachments(?), polls, etc etc here
			$db->query("INSERT INTO ".TABLE_PREFIX."threads (tid,fid,subject,icon,uid,username,dateline,lastpost,lastposter,views,replies,closed,sticky,notes,visible) VALUES (NULL,'$moveto','$thread[subject]','$thread[icon]','$thread[uid]','$thread[username]','$thread[dateline]','$thread[lastpost]','$thread[lastposter]','$thread[views]','$thread[replies]','$thread[closed]','$thread[sticky]','$thread[notes]','1')");
			$newtid = $db->insert_id();
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE tid='$tid'");
			while($post = $db->fetch_array($query))
			{
				if($postssql)
				{
					$postssql .= ", ";
				}
				$postssql .= "(NULL,'$newtid','$moveto','$post[subject]','$post[icon]','$post[uid]','$post[username]','$post[dateline]','$post[message]','$post[ipaddress]','$post[includesig]','$post[smilieoff]','$post[edituid]','$post[edittime]','1')";
			}
			$db->query("INSERT INTO ".TABLE_PREFIX."posts (pid,tid,fid,subject,icon,uid,username,dateline,message,ipaddress,includesig,smilieoff,edituid,edittime,visible) VALUES $postssql");
			logmod($modlogdata, "Thread Copied");
		}
		$query = $db->query("SELECT COUNT(p.pid) AS posts, u.uid FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=p.uid) WHERE tid='$tid' GROUP BY u.uid ORDER BY posts DESC");
		while($posters = $db->fetch_array($query))
		{
			if($method == "copy" && $newforum['usepostcounts'] != "no")
			{
				$pcount = "+$posters[posts]";
			}
			if($method != "copy" && ($newforum['usepostcounts'] != "no" && $forum['usepostcounts'] == "no"))
			{
				$pcount = "+$posters[posts]";
			}
			if($method != "copy" && ($newforum['usepostcounts'] == "no" && $forum['usepostcounts'] != "no"))
			{
				$pcount = "-$posters[posts]";
			}
			$db->query("UPDATE ".TABLE_PREFIX."users SET postnum=postnum$pcount WHERE uid='$posters[uid]'");
		}
		updateforumcount($moveto);
		updateforumcount($fid);
		redirect("showthread.php?tid=$tid", $lang->redirect_threadmoved);
		break;
	
	// Thread notes editor
	case "threadnotes":
		addnav($lang->nav_threadnotes);
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$thread['notes'] = htmlspecialchars($thread['notes']);
		$trow = "trow1";
		$query = $db->query("SELECT l.*, u.username, t.subject AS tsubject, f.name AS fname, p.subject AS psubject FROM ".TABLE_PREFIX."moderatorlog l LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=l.uid) LEFT JOIN ".TABLE_PREFIX."threads t ON (t.tid=l.tid) LEFT JOIN ".TABLE_PREFIX."forums f ON (f.fid=l.fid) LEFT JOIN ".TABLE_PREFIX."posts p ON (p.pid=l.pid) WHERE t.tid='$tid' ORDER BY l.dateline DESC LIMIT  0, 20");
		while($modaction = $db->fetch_array($query))
		{
			$modaction['dateline'] = mydate("jS M Y, G:i", $modaction['dateline']);
			$info = "";
			if($modaction['tsubject'])
			{
				$info .= "<b>$lang->thread</b> <a href=\"showthread.php?tid=$modaction[tid]\" target=\"_blank\">$modaction[tsubject]</a><br>";
			}
			if($modaction['fname'])
			{
				$info .= "<b>$lang->forum</b> <a href=\"forumdisplay.php?fid=$modaction[fid]\" target=\"_blank\">$modaction[fname]</a><br>";
			}
			if($modaction['psubject'])
			{
				$info .= "<b>$lang->post</b> <a href=\"showthread.php?tid=$modaction[tid]&pid=$modaction[pid]#pid$modaction[pid]\">$modaction[psubject]</a>";
			}
	
			eval("\$modactions .= \"".$templates->get("moderation_threadnotes_modaction")."\";");
			if($trow == "trow2")
			{
				$trow = "trow1";
			}
			else
			{
				$trow = "trow2";
			}
		}
		if(!$modactions)
		{
			$modactions = "<tr><td class=\"trow1\" colspan=\"4\">$lang->no_mod_options</td></tr>";
		}
		eval("\$threadnotes = \"".$templates->get("moderation_threadnotes")."\";");
		outputpage($threadnotes);
		break;
	
	// Update the thread notes!
	case "do_threadnotes":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		logmod($modlogdata, "Thread Notes Edited");
		$thread['notes'] = addslashes($threadnotes);
		$db->query("UPDATE ".TABLE_PREFIX."threads SET notes='$thread[notes]' WHERE tid='$tid'");
		redirect("showthread.php?tid=$tid", $lang->redirect_threadnotesupdated);
		break;

	// Lets look up the ip address of a post
	case "getip":
		addnav($lang->nav_getip);
		if(ismod($fid, "canviewips") != "yes")
		{
			nopermission();
		}
	
		$hostname = @gethostbyaddr($post['ipaddress']);
		if(!$hostname || $hostname == $post['ipaddress'])
		{
			$hostname = "N/A (Unable to resolve)";
		}
		eval("\$getip = \"".$templates->get("moderation_getip")."\";");
		outputpage($getip);
		break;

	// Merge threads
	case "merge":
		addnav($lang->nav_merge);
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		eval("\$merge = \"".$templates->get("moderation_merge")."\";");
		outputpage($merge);
		break;

	// Lets get those threads together baby! (Merge threads)
	case "do_merge":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
	
		// get thread to merge's tid
		$splitloc = explode(".php", $threadurl);
		$temp = explode("&", substr($splitloc[1], 1));
		for ($i = 0; $i < count($temp); $i++)
		{
			$temp2 = explode("=", $temp[$i], 2);
			$parameters[$temp2[0]] = $temp2[1];
		}
		if($parameters['pid'] && !$parameters['tid'])
		{
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE pid='$pid'");
			$post = $db->fetch_array($query);
			$mergetid = $post['tid'];
		}
		elseif($parameters['tid'])
		{
			$mergetid = $parameters['tid'];
		}
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."threads WHERE tid='$mergetid'");
		$mergethread = $db->fetch_array($query);
		if(!$mergethread['tid'])
		{
			error($lang->error_badmergeurl);
		}
		if($mergetid == $tid)
		{ // sanity check
			error($lang->error_mergewithself);
		}
		if(ismod($mergethread['fid'], "canmanagethreads") != "yes")
		{
			nopermission();
		}
	
		$pollsql = "";
		if($mergethread['poll'])
		{
			$pollsql = ", poll='$mergethread[poll]'";
			$db->query("UPDATE ".TABLE_PREFIX."polls SET tid='$tid' WHERE tid='$mergethread[tid]'");
		}
		else
		{
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."threads WHERE poll='$mergethread[poll]' AND tid!='$mergethread[tid]'");
			$pollcheck = $db->fetch_array($query);
			if(!$pollcheck['poll'])
			{
				$db->query("DELETE FROM ".TABLE_PREFIX."polls WHERE pid='$mergethread[poll]'");
				$db->query("DELETE FROM ".TABLE_PREFIX."pollvotes WHERE pid='$mergethread[poll]'");
			}
		}
		if(!$subject)
		{
			$subject = $thread['subject'];
		}
		$subject = addslashes($subject);
		$db->query("UPDATE ".TABLE_PREFIX."posts SET tid='$tid', fid='$fid' WHERE tid='$mergetid'");
		$db->query("UPDATE ".TABLE_PREFIX."threads SET subject='$subject' $pollcode WHERE tid='$tid'");
		$db->query("UPDATE ".TABLE_PREFIX."threads SET closed='moved|$tid' WHERE closed='moved|$mergetid'");
		$db->query("UPDATE ".TABLE_PREFIX."favorites SET tid='$tid' WHERE tid='$mergetid'");

		logmod($modlogdata, "Thread Merged");
		deletethread($mergetid);
		updatethreadcount($tid);
		if($fid != $mergethread['fid'])
		{
			updateforumcount($mergethread['fid']);
		}
		updateforumcount($fid);
		redirect("showthread.php?tid=$tid", $lang->redirect_threadsmerged);
		break;

	// Divorce the posts in this thread (Split!)
	case "split":
		addnav($lang->nav_split);
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$query = $db->query("SELECT p.*, u.* FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (p.uid=u.uid) WHERE tid='$tid' ORDER BY dateline ASC");	
		$numposts = $db->num_rows($query);
		if($numposts <= "1")
		{
			error($lang->error_cantsplitonepost);
		}
	
		$altbg = "trow1";
		while($post = $db->fetch_array($query))
		{
			$postdate = mydate($settings['dateformat'], $post['dateline']);
			$posttime = mydate($settings['timeformat'], $post['dateline']);
			$message = stripslashes($post['message']);
			if($post['smilieoff'] == "yes")
			{
				$allowsmilies = "no";
			}
			else
			{
				$allowsmilies = $forum['allowsmilies'];
			}
			$message = postify($message, $forum['allowhtml'], $forum['allowmycode'], $allowsmilies, $forum['allowimgcode']);
			eval("\$posts .= \"".$templates->get("moderation_split_post")."\";");
			if($altbg == "trow1")
			{
				$altbg = "trow2";
			}
			else
			{
				$altbg = "trow1";
			}
		}
		$forumselect = makeforumjump("", $fid, 1, "", 0, "moveto");
		eval("\$split = \"".$templates->get("moderation_split")."\";");
		outputpage($split);
		break;

	// Lets break them up buddy! (Do the split)
	case "do_split":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$numyes = "0";
		$numno = "0";
		while(list($key, $val) = each($splitpost))
		{
			if($val == "yes")
			{
				$numyes++;
			}
			else
			{
				$numno++;
			}
		}
		if(!$numyes && $numno)
		{
			error($lang->error_nosplitposts);
		}
		if($numyess && !$numno)
		{
			error($lang->error_cantsplitall);
		}
		if(!$moveto)
		{
			$moveto = $fid;
		}
		$newsubject = addslashes($newsubject);
		$db->query("INSERT INTO ".TABLE_PREFIX."threads (tid,fid,subject,icon,uid,username,dateline,lastpost,lastposter,replies,visible) VALUES (NULL,'$moveto','$newsubject','$thread[icon]','$thread[uid]','$thread[username]','$thread[dateline]','$thread[lastpost]','$thread[lastposter]','$numyes','1')");
		$newtid = $db->insert_id();
		// move the selected posts over
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE tid='$tid'");
		while($post = $db->fetch_array($query))
		{
			if($splitpost[$post['pid']] == "yes")
			{
				$db->query("UPDATE ".TABLE_PREFIX."posts SET tid='$newtid', fid='$moveto' WHERE pid='$post[pid]'");
			}
			markreports($post['pid'], "post");
		}
		logmod($modlogdata, "Thread Split");
		updatethreadcount($tid);
		updatethreadcount($newtid);
		if($moveto != $fid)
		{
			updateforumcount($moveto);
		}
		updateforumcount($fid);
		redirect("showthread.php?tid=$newtid", $lang->redirect_threadsplit);
		break;
	
	// Delete Threads - Inline moderation
	case "multideletethreads":
		addnav($lang->nav_multi_deletethreads);
		if(ismod($fid, "candeleteposts") != "yes")
		{
			if($permissions['candeletethreads'] != "yes" || $GBB['uid'] != $thread['uid'])
			{
				nopermission();
			}
		}
		$threads = getids($fid, "forum");
		if(!is_array($threads))
		{
			error($lang->error_inline_nothreadsselected);
		}
		$inlineids = implode("|", $threads);
		clearinline($fid, "forum");
		eval("\$multidelete = \"".$templates->get("moderation_inline_deletethreads")."\";");
		outputpage($multidelete);
		break;

	// Actually delete the threads - Inline moderation
	case "do_multideletethreads":
		if(ismod($fid, "candeleteposts") != "yes")
		{
			if($permissions['candeletethreads'] != "yes" || $GBB['uid'] != $thread['uid'])
			{
				nopermission();
			}
		}
		$threadlist = explode("|", $threads);
		foreach($threadlist as $tid)
		{
			deletethread($tid);
			$tlist[] = $tid;
		}
		updateforumcount($fid);
		logmod($modlogdata, "Threads Deleted in: ".$forun['name']);
		clearinline($fid, "forum");
		markreports($tlist, "threads");
		redirect("forumdisplay.php?fid=$fid", $lang->redirect_inline_threadsdeleted);
		break;

	case "multiopenthreads":
		if(ismod($fid, "canopenclosethreads") != "yes")
		{
			nopermission();
		}
		$threads = getids($fid, "forum");
		if(!is_array($threads))
		{
			error($lang->error_inline_nothreadsselected);
		}
		$q = "tid='-1'";
		foreach($threads as $tid)
		{
			$q .= " OR tid='$tid'";
		}
		$db->query("UPDATE ".TABLE_PREFIX."threads SET closed='no' WHERE $q");
		logmod($modlogdata, "Threads opened in: ".$forun['name']);
		clearinline($fid, "forum");
		redirect("forumdisplay.php?fid=$fid", $lang->redirect_inline_threadsopened);
		break;

	case "multiclosethreads":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$threads = getids($fid, "forum");
		if(!is_array($threads))
		{
			error($lang->error_inline_nothreadsselected);
		}
		$q = "tid='-1'";
		foreach($threads as $tid)
		{
			$q .= " OR tid='$tid'";
		}
		$db->query("UPDATE ".TABLE_PREFIX."threads SET closed='yes' WHERE $q");
		logmod($modlogdata, "Threads closed in: ".$forun['name']);
		clearinline($fid, "forum");
		redirect("forumdisplay.php?fid=$fid", $lang->redirect_inline_threadsclosed);
		break;

	case "multistickthreads":
		if(ismod($fid, "canopenclosethreads") != "yes")
		{
			nopermission();
		}
		$threads = getids($fid, "forum");
		if(!is_array($threads))
		{
			error($lang->error_inline_nothreadsselected);
		}
		$q = "tid='-1'";
		foreach($threads as $tid)
		{
			$q .= " OR tid='$tid'";
		}
		$db->query("UPDATE ".TABLE_PREFIX."threads SET sticky='1' WHERE $q");
		logmod($modlogdata, "Threads stuck in: ".$forun['name']);
		clearinline($fid, "forum");
		redirect("forumdisplay.php?fid=$fid", $lang->redirect_inline_threadsstuck);
		break;

	case "multiunstickthreads":
		if(ismod($fid, "canopenclosethreads") != "yes")
		{
			nopermission();
		}
		$threads = getids($fid, "forum");
		if(!is_array($threads))
		{
			error($lang->error_inline_nothreadsselected);
		}
		$q = "tid='-1'";
		foreach($threads as $tid)
		{
			$q .= " OR tid='$tid'";
		}
		$db->query("UPDATE ".TABLE_PREFIX."threads SET sticky='0' WHERE $q");
		logmod($modlogdata, "Threads unstuck in: ".$forun['name']);
		clearinline($fid, "forum");
		redirect("forumdisplay.php?fid=$fid", $lang->redirect_inline_threadsunstuck);
		break;

	case "multimovethreads":
		addnav($lang->nav_multi_movethreads);
		$threads = getids($fid, "forum");
		if(!is_array($threads))
		{
			error($lang->error_inline_nothreadsselected);
		}
		$inlineids = implode("|", $threads);
		clearinline($fid, "forum");

		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$forumselect = makeforumjump("", "", 1, "", 0, "", "moveto");
		eval("\$movethread = \"".$templates->get("moderation_inline_movethreads")."\";");
		outputpage($movethread);
		break;
	case "do_multimovethreads":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$q = "tid='-1'";
		$threadlist = explode("|", $threads);
		foreach($threadlist as $tid)
		{
			$q .= " OR tid='$tid'";
		}
		if(ismod($moveto, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$newperms = getpermissions($moveto);
		if($newperms['canview'] == "no")
		{
			nopermission();
		}
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."forums WHERE fid='$moveto'");
		$newforum = $db->fetch_array($query);
		if($newforum['type'] != "f")
		{
			error($lang->error_invalidforum);
		}
		if($thread['fid'] == $moveto)
		{
			error($lang->error_movetosameforum);
		}
		$db->query("UPDATE ".TABLE_PREFIX."threads SET fid='$moveto' WHERE $q");
		$db->query("UPDATE ".TABLE_PREFIX."posts SET fid='$moveto' WHERE $q");
		logmod($modlogdata, "Threads Moved");
		$query = $db->query("SELECT COUNT(p.pid) AS posts, u.uid FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=p.uid) WHERE $q GROUP BY u.uid ORDER BY posts DESC");
		while($posters = $db->fetch_array($query))
		{
			if($method == "copy" && $newforum['usepostcounts'] != "no")
			{
				$pcount = "+$posters[posts]";
			}
			if($method != "copy" && ($newforum['usepostcounts'] != "no" && $forum['usepostcounts'] == "no"))
			{
				$pcount = "+$posters[posts]";
			}
			if($method != "copy" && ($newforum['usepostcounts'] == "no" && $forum['usepostcounts'] != "no"))
			{
				$pcount = "-$posters[posts]";
			}
			$db->query("UPDATE ".TABLE_PREFIX."users SET postnum=postnum$pcount WHERE uid='$posters[uid]'");
		}
		updateforumcount($moveto);
		updateforumcount($fid);
		redirect("forumdisplay.php?fid=$moveto", $lang->redirect_inline_threasdmoved);
		break;
	case "multideleteposts":
		addnav($lang->nav_multi_deleteposts);
		if(ismod($fid, "candeleteposts") != "yes")
		{
			nopermission();
		}
		$posts = getids($tid, "thread");
		if(!is_array($posts))
		{
			error($lang->error_inline_nopostsselected);
		}
		$inlineids = implode("|", $posts);
		clearinline($pid, "post");

		if(!is_array($posts))
		{
			error($lang->error_inline_nopostsselected);
		}
		eval("\$multidelete = \"".$templates->get("moderation_inline_deleteposts")."\";");
		outputpage($multidelete);
		break;
	case "do_multideleteposts":
		if(ismod($fid, "candeleteposts") != "yes")
		{
			nopermission();
		}
		$postlist = explode("|", $posts);
		foreach($postlist as $pid)
		{
			deletepost($pid);
			$plist[] = $pid;
		}
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE tid='$tid'");
		$numposts = $db->num_rows($query);
		if(!$numposts)
		{
			deletethread($tid);
			markreports($tid, "thread");
			$url = "forumdisplay.php?fid=$fid";
		}
		else
		{
			updatethreadcount($tid);
			markreports($plist, "posts");
			$url = "showthread.php?tid=$tid";
		}
		logmod($modlogdata, "Deleted Selective Posts ($deletecount)");
		updateforumcount($fid);
		redirect($url, $lang->redirect_postsdeleted);
		break;
	case "multimergeposts":
		addnav($lang->nav_multi_mergeposts);
		if(ismod($fid, "candeleteposts") != "yes")
		{
			nopermission();
		}
		$posts = getids($tid, "thread");
		if(!is_array($posts))
		{
			error($lang->error_inline_nopostsselected);
		}
		$inlineids = implode("|", $posts);
		clearinline($tid, "thread");

		eval("\$multimerge = \"".$templates->get("moderation_inline_mergeposts")."\";");
		outputpage($multimerge);
		break;
	case "do_multimergeposts":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$postlist = explode("|", $posts);
		foreach($postlist as $pid)
		{
				$pidin .= "$comma'$pid'";
				$comma = ",";
				$plist[] = $pid;
		}
		$first = 1;
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE tid='$tid' AND pid IN($pidin) ORDER BY dateline ASC");
		while($post = $db->fetch_array($query))
		{
			if($first == 1)
			{ // all posts will be merged into this one
				$masterpid = $post['pid'];
				$message = $post['message'];
			}
			else
			{ // these are the selected posts
				if($sep == "newline")
				{
					$message .= "\n\n$post[message]";
				}
				else
				{
					$message .= "[hr]$post[message]";
				}
			}
			$first = 0;
		}
		$message = addslashes($message);
		$db->query("UPDATE ".TABLE_PREFIX."posts SET message='$message' WHERE pid='$masterpid'");
		$db->query("DELETE FROM ".TABLE_PREFIX."posts WHERE pid IN($pidin) AND pid!='$masterpid'");
		$db->query("UPDATE ".TABLE_PREFIX."posts SET pid='$masterpid' WHERE pid IN($pidin)");
		updatethreadcount($tid);
		updateforumcount($fid);
		markreports($plist, "posts");
		logmod($modlogdata, "Merge Selective Posts");
		redirect("showthread.php?tid=$tid", $lang->redirect_inline_postsmerged);
		break;
	case "multisplitposts":
		addnav($lang->nav_multi_splitposts);
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$query = $db->query("SELECT p.*, u.* FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (p.uid=u.uid) WHERE tid='$tid' ORDER BY dateline ASC");	
		$numposts = $db->num_rows($query);
		if($numposts <= "1")
		{
			error($lang->error_cantsplitonepost);
		}
		$posts = getids($tid, "thread");
		foreach($posts as $pid)
		{
				$pidin .= "$comma'$pid'";
				$comma = ",";
		}
		if(!is_array($posts))
		{
			error($lang->error_inline_nopostsselected);
		}
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."posts WHERE pid NOT IN($pidin) AND tid='$tid'");
		$num = $db->num_rows($query);
		if(!$num)
		{
			error($lang->error_cantsplitall);
		}
		$inlineids = implode("|", $posts);
		clearinline($tid, "thread");
		$forumselect = makeforumjump("", "", 1, "", 0, "", "moveto");
		eval("\$splitposts = \"".$templates->get("moderation_inline_splitposts")."\";");
		outputpage($splitposts);
		break;
	case "do_multisplitposts":
		if(ismod($fid, "canmanagethreads") != "yes")
		{
			nopermission();
		}
		$postlist = explode("|", $posts);
		foreach($postlist as $pid)
		{
			$pidin .= "$comma'$pid'";
			$comma = ",";
			$plist[] = $pid;
		}
		if(!$moveto)
		{
			$moveto = $fid;
		}
		$newsubject = addslashes($newsubject);
		$db->query("INSERT INTO ".TABLE_PREFIX."threads (tid,fid,subject,icon,uid,username,dateline,lastpost,lastposter,replies,visible) VALUES (NULL,'$moveto','$newsubject','$thread[icon]','$thread[uid]','$thread[username]','$thread[dateline]','$thread[lastpost]','$thread[lastposter]','$numyes','1')");
		$newtid = $db->insert_id();
		// move the selected posts over
		$db->query("UPDATE ".TABLE_PREFIX."posts SET tid='$newtid', fid='$moveto' WHERE pid IN($pidin)");
		logmod($modlogdata, "Thread Split");
		markreports($plist, "posts");
		updatethreadcount($tid);
		updatethreadcount($newtid);
		if($moveto != $fid)
		{
			updateforumcount($moveto);
		}
		updateforumcount($fid);
		redirect("showthread.php?tid=$newtid", $lang->redirect_threadsplit);
		break;
	case "do_reports":
		if(!ismod())
		{
			nopermission();
		}
		$perms = getpermissions("0", $uid);
		$flist = "";
		if($perms['issupermod'] != "yes")
		{
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."moderators WHERE uid='$GBB[uid]'");
			while($forum = $db->fetch_array($query))
			{
				$flist .= ",'".$forum['fid']."'";
			}
		}
		if($flist)
		{
			$flist = "AND fid IN (0$flist)";
		}
		if(!is_array($reports))
		{
			error($lang->error_noselected_reports);
		}
		$rids = implode($reports, "','");
		$rids = "'0','$rids'";
		$db->query("UPDATE ".TABLE_PREFIX."reportedposts SET reportstatus='1' WHERE rid IN ($rids)");
		$cache->updatereportedposts();
		redirect("moderation.php?action=reports", $lang->redirect_reportsmarked);
		break;
	case "reports":
		if(!ismod())
		{
			nopermission();
		}
		$perms = getpermissions("0", $uid);
		$flist = "";
		if($perms['issupermod'] != "yes")
		{
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."moderators WHERE uid='$GBB[uid]'");
			while($forum = $db->fetch_array($query))
			{
				$flist .= ",'".$forum['fid']."'";
			}
		}
		if($flist)
		{
			$flist2 = "WHERE fid IN (0$flist)";
			$flistr = "WHERE r.fid IN (0$flist)";
		}
		$query = $db->query("SELECT fid,name FROM ".TABLE_PREFIX."forums $flist2");
		while($forum = $db->fetch_array($query))
		{
			$forums[$forum['fid']] = $forum['name'];
		}
		$trow = "trow1";
		$query = $db->query("SELECT r.*, u.username, up.username AS postusername, up.uid AS postuid, t.subject AS threadsubject FROM ".TABLE_PREFIX."reportedposts r LEFT JOIN ".TABLE_PREFIX."posts p ON (r.pid=p.pid) LEFT JOIN ".TABLE_PREFIX."threads t ON (p.tid=t.tid) LEFT JOIN ".TABLE_PREFIX."users u ON (r.uid=u.uid) LEFT JOIN ".TABLE_PREFIX."users up ON (p.uid=up.uid) WHERE r.reportstatus ='0' $flistr ORDER BY r.dateline ASC");
		while($report = $db->fetch_array($query))
		{
			$reportdate = mydate($settings['dateformat'], $report['dateline']);
			$reporttime = mydate($settings['timeformat'], $report['dateline']);
			eval("\$reports .= \"".$templates->get("moderation_reports_report")."\";");
			if($trow == "trow2")
			{
				$trow = "trow1";
			}
			else
			{
				$trow = "trow1";
			}
		}
		if(!$reports)
		{
			eval("\$reports = \"".$templates->get("moderation_reports_noreports")."\";");
		}
		eval("\$reportedposts = \"".$templates->get("moderation_reports")."\";");
		outputpage($reportedposts);
		break;
	default:
		break;
}

// Some little handy functions for our inline moderation
function getids($id, $type)
{
	global $HTTP_COOKIE_VARS;
	$cookie = "inlinemod_".$type.$id;
	$ids = explode("|", $HTTP_COOKIE_VARS[$cookie]);
	foreach($ids as $id)
	{
		if($id != "")
		{
			$newids[] = $id;
		}
	}
	return $newids;
}


function clearinline($id, $type)
{
	myunsetcookie("inlinemod_".$type.$id);
}

function extendinline($id, $type)
{
	global $_COOKIE;
	setcookie("inlinemod_$type$id", "", time()+3600);
}
